/* 
 *  $Id: disk.h,v 1.10 1995/08/21 07:04:31 duane Exp $
 **********************************************************************
 *  Copyright (c) 1994, 1995.  All rights reserved.
 *  
 *          Mic Bowman of Transarc Corporation.
 *          Peter Danzig of the University of Southern California.
 *          Darren R. Hardy of the University of Colorado at Boulder.
 *          Udi Manber of the University of Arizona.
 *          Michael F. Schwartz of the University of Colorado at Boulder. 
 *          Duane Wessels of the University of Colorado at Boulder. 
 *  
 *  This copyright notice applies to all code in Harvest other than
 *  subsystems developed elsewhere, which contain other copyright notices
 *  in their source text.
 *  
 *  The Harvest software was developed by the Internet Research Task
 *  Force Research Group on Resource Discovery (IRTF-RD).  The Harvest
 *  software may be used for academic, research, government, and internal
 *  business purposes without charge.  If you wish to sell or distribute
 *  the Harvest software to commercial clients or partners, you must
 *  license the software.  See
 *  http://harvest.cs.colorado.edu/harvest/copyright,licensing.html#licensing.
 *  
 *  The Harvest software is provided ``as is'', without express or
 *  implied warranty, and with no support nor obligation to assist in its
 *  use, correction, modification or enhancement.  We assume no liability
 *  with respect to the infringement of copyrights, trade secrets, or any
 *  patents, and are not responsible for consequential damages.  Proper
 *  use of the Harvest software is entirely the responsibility of the user.
 *  
 *  For those who are using Harvest for non-commercial purposes, you may
 *  make derivative works, subject to the following constraints:
 *  
 *  - You must include the above copyright notice and these accompanying 
 *    paragraphs in all forms of derivative works, and any documentation 
 *    and other materials related to such distribution and use acknowledge 
 *    that the software was developed at the above institutions.
 *  
 *  - You must notify IRTF-RD regarding your distribution of the 
 *    derivative work.
 *  
 *  - You must clearly notify users that your are distributing a modified 
 *    version and not the original Harvest software.
 *  
 *  - Any derivative product is also subject to the restrictions of the 
 *    copyright, including distribution and use limitations.
 *  
 */
#ifndef DISK_H
#define DISK_H

#include "ansihelp.h"

#define DISK_OK                   (0)
#define DISK_ERROR               (-1)
#define DISK_EOF                 (-2)
#define DISK_WRT_LOCK_FAIL       (-3)
#define DISK_WRT_WRONG_CODE      (-4)
#define DISK_FILE_NOT_FOUND      (-5)
#define DISK_NO_SPACE_LEFT       (-6)

typedef int (*FILE_READ_HD) _PARAMS((int fd, char *buf, int size, int errflag,
				     caddr_t data, int offset));

typedef int (*FILE_WALK_HD) _PARAMS((int fd, int errflag, caddr_t data));

typedef int (*FILE_WALK_LHD) _PARAMS((int fd, char *buf, int size, caddr_t line_data));



extern int file_open _PARAMS((char *path, int (*handler) (), int mode));
extern int file_close _PARAMS((int fd));
extern int file_write _PARAMS((int fd, caddr_t buf, int len, int access_code,
			       void (*handle) (), void *handle_data));
extern int file_read _PARAMS((int fd, caddr_t buf, int req_len, int offset,
			      int (*handler) (int fd, char *buf, int size,
				  int errflag, caddr_t data, int offset),
			      caddr_t client_data));
extern int file_walk _PARAMS((int fd,
		      int (*handler) (int fd, int errflag, caddr_t data),
			      caddr_t client_data,
			      int (*line_handler)
		        (int fd, char *buf, int size, caddr_t line_data),
			      caddr_t line_data));
extern int file_get_fd _PARAMS((char *filename));

#endif				/* DISK_H */
