/* 
 *  $Id: neighbors.h,v 1.11 1995/07/27 17:04:40 hardy Exp $
 *
 *  File:         neighbors.h
 *  Description:  
 *  Author:       Peter Danzig, USC
 *  Created:      May 1994
 *  Language:     C
 **********************************************************************
 *  Copyright (c) 1994, 1995.  All rights reserved.
 *  
 *          Mic Bowman of Transarc Corporation.
 *          Peter Danzig of the University of Southern California.
 *          Darren R. Hardy of the University of Colorado at Boulder.
 *          Udi Manber of the University of Arizona.
 *          Michael F. Schwartz of the University of Colorado at Boulder. 
 *          Duane Wessels of the University of Colorado at Boulder. 
 *  
 *  This copyright notice applies to all code in Harvest other than
 *  subsystems developed elsewhere, which contain other copyright notices
 *  in their source text.
 *  
 *  The Harvest software was developed by the Internet Research Task
 *  Force Research Group on Resource Discovery (IRTF-RD).  The Harvest
 *  software may be used for academic, research, government, and internal
 *  business purposes without charge.  If you wish to sell or distribute
 *  the Harvest software to commercial clients or partners, you must
 *  license the software.  See
 *  http://harvest.cs.colorado.edu/harvest/copyright,licensing.html#licensing.
 *  
 *  The Harvest software is provided ``as is'', without express or
 *  implied warranty, and with no support nor obligation to assist in its
 *  use, correction, modification or enhancement.  We assume no liability
 *  with respect to the infringement of copyrights, trade secrets, or any
 *  patents, and are not responsible for consequential damages.  Proper
 *  use of the Harvest software is entirely the responsibility of the user.
 *  
 *  For those who are using Harvest for non-commercial purposes, you may
 *  make derivative works, subject to the following constraints:
 *  
 *  - You must include the above copyright notice and these accompanying 
 *    paragraphs in all forms of derivative works, and any documentation 
 *    and other materials related to such distribution and use acknowledge 
 *    that the software was developed at the above institutions.
 *  
 *  - You must notify IRTF-RD regarding your distribution of the 
 *    derivative work.
 *  
 *  - You must clearly notify users that your are distributing a modified 
 *    version and not the original Harvest software.
 *  
 *  - Any derivative product is also subject to the restrictions of the 
 *    copyright, including distribution and use limitations.
 *  
 */
#ifndef NEIGHBORS_H
#define NEIGHBORS_H

#include "ansihelp.h" /* For _PARAMS */

#define isNeighbor( X ) (!((X).type))
#define isParent( X )   ((X).type)

/* for hierachical log file */
#define HIER_DIRECT "DIRECT"
#define HIER_NEIGHBOR "NEIGHBOR"
#define HIER_PARENT_HIT "PARENT_HIT"
#define HIER_PARENT_MISS "PARENT_MISS"
#define HIER_NO_PARENT "NO_PARENT_DIRECT"

typedef struct _edge {
    char *host;
    struct sockaddr_in in_addr;
    int rtt;
    int type;			/* 0 if neighbor, 1 if parent */
    int udp_port;
    int tcp_port;
    int ascii_port;
    icp_common_t header;
} edge;


/* Proto-types */
edge *neighbors_get _PARAMS((char *host, int ascii_port, int tcp_port, 
	int udp_port));

void neighbors_install _PARAMS((char *host, char *type, 
	int ascii_port, int tcp_port, int udp_port));
#endif
